#region Copyright Syncfusion Inc. 2001-2017.
// Copyright Syncfusion Inc. 2001-2017. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using System.IO;
using System;
using System.Collections.Generic;
using System.Reflection;
using Android.Content;
using Android.Views;
using Android.Widget;
using Android.Graphics;

namespace SampleBrowser
{
    public partial class WordToHTML : SamplePage
    {
		private Context m_context;
		public override View GetSampleContent (Context con)
		{
			LinearLayout linear = new LinearLayout(con);
			linear.SetBackgroundColor(Color.White);
			linear.Orientation = Orientation.Vertical;
			linear.SetPadding(10, 10, 10, 10);

			TextView text1 = new TextView(con);
			text1.TextSize = 17;
			text1.TextAlignment = TextAlignment.Center;
			text1.SetTextColor(Color.ParseColor("#262626"));
		    text1.Text = "This sample demonstrates how to convert the Word document into HTML file.";
			text1.SetPadding(5, 10, 10, 5);
			linear.AddView(text1);


			TextView space1 = new TextView (con);
			space1.TextSize = 10;
			linear.AddView (space1);
			
            TextView text3 = new TextView(con);
			text3.TextSize = 17;
			text3.TextAlignment = TextAlignment.Center;
			text3.Text = "Click “Generate” button to view the HTML document generated by DocIO.";
			text3.SetTextColor(Color.ParseColor("#262626"));
			text3.SetPadding(5, 5, 5, 5);

			linear.AddView(text3);

			m_context = con;

			TextView space2 = new TextView (con);
			space2.TextSize = 10;
			linear.AddView (space2);

			Button button1 = new Button (con);
			button1.Text = "Generate";
			button1.Click += OnButtonClicked;
			linear.AddView (button1);

			return linear;

		}
        void OnButtonClicked(object sender, EventArgs e)
		{
			Assembly assembly = Assembly.GetExecutingAssembly ();
			// Creating a new document.
			WordDocument document = new WordDocument ();
            // Gets input stream from embedded resource.
			Stream inputStream = assembly.GetManifestResourceStream ("SampleBrowser.Samples.DocIO.Templates.TestIfField.doc");
			// Opens the Word document.
			document.Open (inputStream, FormatType.Doc);
            // Gets merge field names from Word document.
            var listeChamps = document.MailMerge.GetMergeFieldNames();
            // Gets values for merge fields in the Word document.
            var listeValeurs = new List<string>();
            for (int i = 0; i < listeChamps.Length; i++)
            {
                if (listeChamps[i] == "MesureCO")
                    listeValeurs.Add("10");
                else if (listeChamps[i] == "Gender")
                    listeValeurs.Add("No male");
                else if (listeChamps[i] == "AddressField")
                    listeValeurs.Add("My custom adresse");
                else
                    listeValeurs.Add(string.Format("Valeur {0}", listeChamps[i]));
            }
            // Performs Mail merge with field names and its values.
            document.MailMerge.Execute(listeChamps, listeValeurs.ToArray());
            // Updates fields in the Word document.
            document.UpdateDocumentFields();
			//Export the Word document to HTML file
			MemoryStream stream = new MemoryStream ();
			HTMLExport htmlExport = new HTMLExport ();
			htmlExport.SaveAsXhtml (document, stream);
			document.Close ();
			//Set the stream to start position to read the content as string
			stream.Position = 0;
			StreamReader reader = new StreamReader (stream);
			string htmlString = reader.ReadToEnd ();
            // Shows resultant HTML file using WebView.
			Intent intent = new Intent (m_context, typeof(WebViewActivity));
            intent.PutExtra ("HtmlString", htmlString);
			m_context.StartActivity (intent);
        }
	}			
}

